-- Copilot AddOn LUA-Script ------------------------------------------
-- Version 0.1                                                      --
-- 9.5.2014                                                         --
-- by oe3gsu member of AXDG                                         --
-- oe3gsu@x-plane.at                                                --
-- http:\\www.x-plane.at                                            --
----------------------------------------------------------------------


-- USER editable values -------------------------------------------------------------------------------
--                                                                                                   --
--                 there are no, i repeat: NO user-editable values in this script !!!                --
--                 all changeable values you can modify in the running script                        --
--                                 PLEASE READ THE MANUAL                                            --
--                                                                                                   --
-- END     DONT edit anything below this line !!! -----------------------------------------------------



require"graphics"
require "radio"

sound_welcome = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/welcome.wav")
sound_command = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/command.wav")
sound_coffee  = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/coffee.wav")
sound_gearup  = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/gearup.wav")
sound_geardown = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/geardown.wav")
sound_gearisup  = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/gearisup.wav")
sound_gearisdown = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/gearisdown.wav")
sound_qnhstd  = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/qnh_standard.wav")
sound_qnhloc  = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/qnh_local.wav")
sound_flaps_up = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/flaps_up.wav")
sound_flaps_down = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/flaps_down.wav")
sound_squawk_on = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/squawk_on.wav")
sound_squawk_off = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/squawk_off.wav")
sound_squawk_stby = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/squawk_stby.wav")
sound_warning = load_WAV_file(SCRIPT_DIRECTORY .. "CPT_sounds/warning.wav")

add_macro("Copilot tab", "CPT_show = true", "CPT_show = false", "activate")

dataref("CPT_xp_gs_act", "sim/flightmodel/position/groundspeed")  
dataref("CPT_xp_y_agl", "sim/cockpit2/gauges/indicators/radio_altimeter_height_ft_pilot")
dataref("CPT_xp_fnrml_gear", "sim/flightmodel/forces/fnrml_gear")
dataref("CPT_xp_cur_alt", "sim/cockpit2/gauges/indicators/altitude_ft_pilot", "readonly")
dataref("CPT_xp_OM_lit", "sim/cockpit/misc/over_outer_marker")
dataref("CPT_xp_bat_on", "sim/cockpit/electrical/battery_on")
dataref("CPT_xp_gear_handle", "sim/cockpit2/controls/gear_handle_down","writable")
dataref("CPT_xp_gear_unsafe", "sim/cockpit/warnings/annunciators/gear_unsafe", "readonly")
dataref("CPT_xp_QNH_pilot", "sim/cockpit2/gauges/actuators/barometer_setting_in_hg_pilot", "writable")
dataref("CPT_xp_QNH_real", "sim/weather/barometer_sealevel_inhg", "writable")
dataref("CPT_xp_AoA", "sim/flightmodel2/misc/AoA_angle_degrees")
dataref("CPT_xp_flap_handle", "sim/cockpit2/controls/flap_ratio", "writable")               -- Flap Handle
dataref("CPT_xp_flap_pos", "sim/cockpit2/controls/flap_handle_deploy_ratio", "writable")    -- Flap Anzeige
dataref("CPT_xp_flap_step", "sim/aircraft/controls/acf_flap_detents")                       -- Flap Steps

dataref("CPT_xp_beacon", "sim/cockpit2/switches/beacon_on", "writable")                     -- beacon Lights Switch
dataref("CPT_xp_navlight", "sim/cockpit/electrical/nav_lights_on", "writable")              -- Nav Lights Switch
dataref("CPT_xp_landlight", "sim/cockpit/electrical/landing_lights_on", "writable")         -- Landing Lights Switch
dataref("CPT_xp_strobelight", "sim/cockpit/electrical/strobe_lights_on", "writable")        -- Strobe Lights Switch
dataref("CPT_xp_taxilight", "sim/cockpit/electrical/taxi_light_on", "writable")             -- Taxi Lights Switch
dataref("CPT_xp_eng_count", "sim/aircraft/engine/acf_num_engines")                          -- Number of Engines


local gear_deployment = dataref_table("sim/aircraft/parts/acf_gear_deploy")                 
local gear_leglen = dataref_table("sim/aircraft/parts/acf_gear_leglen")

dataref("CPT_xp_Vso", "sim/aircraft/view/acf_Vso")   -- Stall speed or minimum flight speed in landing configuration
dataref("CPT_xp_Vs", "sim/aircraft/view/acf_Vs")     -- Stall speed or minimum steady flight speed for which the aircraft is still controllable
dataref("CPT_xp_Vfe", "sim/aircraft/view/acf_Vfe")   -- Maximum flap extended speed
dataref("CPT_xp_Vno", "sim/aircraft/view/acf_Vno")   -- Maximum structural cruising speed or maximum speed for normal operations
dataref("CPT_xp_Vne", "sim/aircraft/view/acf_Vne")   -- Never exceed speed
dataref("CPT_xp_IAS", "sim/flightmodel/position/indicated_airspeed")

local CPT_show = true              -- Show CPT-TAB
local CPT_func = false             -- Show functions
local CPT_on   = true              -- CPT ON/OFF
local CPT_voice = false             -- Voice ON/OFF
local CPT_gear = true              -- CPT makes GEAR
local CPT_ATC = true               -- CPT makes ATC
local CPT_QNH = true               -- CPT makes QNH
local CPT_flap = true              -- CPT makes Flaps
local CPT_flap_last = 0            -- Time flaps last movement
local CPT_flap_time = 10           -- Time to wait before new flap movement
local CPT_beacon = true            -- CPT makes Beacon Lights
local CPT_navl = true              -- CPT makes Nav Lights
local CPT_LL = true                -- CPT makes Landing Lights
local CPT_strobe = true            -- CPT makes Strobe Lights
local CPT_taxi = true              -- CPT makes Taxi Lights

local CPT_flap_d1 = 5.0                             -- AoA to extend flaps when cruising
local CPT_flap_d2 = 10.0                             -- AoA to extend flaps on the final
local CPT_flap_u1 = -0.5                             -- AoA to reduce flaps
local CPT_QNH_inhg = false                           -- show QNH as inHg (=true) else hPA
local CPT_QNH_trans = 5000.0                        -- Transition Start-Altitude in ft 
local CPT_set_trans = 0        -- User set Transition Alt

CPT_flap_step = 1 / CPT_xp_flap_step
if CPT_flap_step > 0.25 then CPT_flap_step = 0.25 end

local CPT_agl_old = 0
local CPT_gear_old = 0
local CPT_ATC_t = 0
local CPT_ACT_h = 0
local CPT_ACT_z = 0
local CPT_ACT_e = 0
local CPT_y_agl_ft = 0
local CPT_last_y_agl = 0
local CPT_last_fnrml_gear = 0
local CPT_last_gs = 0
local CPT_last_heigt = 0

local CPT_count = 0
local CPT_status = 0
local CPT_old_status = 0
local CPT_dips_stat_flap = 0

local CPT_any_eng_run = 0

local CPT_axis_flap = 0
local CPT_axis_gear = 0

local CPT_message = ""
local CPT_message_time = 7
local CPT_message_end = 0
local CPT_sound_played = false

local CPT_debug = false

local CPT_parm = {CPT_func, CPT_on, CPT_voice, CPT_gear, CPT_ATC, CPT_QNH, CPT_flap, CPT_beacon, CPT_navl, CPT_LL, CPT_strobe, CPT_taxi, CPT_flap_d1, CPT_flap_d2, CPT_flap_u1, CPT_flap_time, CPT_QNH_inhg, CPT_QNH_trans}

function CPT_load_settings()
	
  file = io.open(AIRCRAFT_PATH .. string.sub(AIRCRAFT_FILENAME, 1, string.len(AIRCRAFT_FILENAME)- 4) .. ".cpt", "r")
  if file == nil then file = io.open(SCRIPT_DIRECTORY .. "CPT_std.cpt", "r") end
    
	for i=1, table.getn(CPT_parm) do
		rd = file:read("*line")
		CPT_parm[i] = rd
		i = i+1
	  if rd == nil then 
	  file:close()
	  break end
	end
	
  if CPT_parm[1] == "true" then CPT_func = true else CPT_func = false end
  if CPT_parm[2] == "true" then CPT_on = true else CPT_on = false end
  if CPT_parm[3] == "true" then CPT_voice = true else CPT_voice = false end
  if CPT_parm[4] == "true" then CPT_gear = true else CPT_gear = false end
  if CPT_parm[5] == "true" then CPT_ATC = true else CPT_ATC = false end
  if CPT_parm[6] == "true" then CPT_QNH = true else CPT_QNH = false end
  if CPT_parm[7] == "true" then CPT_flap = true else CPT_flap = false end
  if CPT_parm[8] == "true" then CPT_beacon = true else CPT_beacon = false end
  if CPT_parm[9] == "true" then CPT_navl = true else CPT_navl = false end
  if CPT_parm[10] == "true" then CPT_LL = true else CPT_LL = false end
  if CPT_parm[11] == "true" then CPT_strobe = true else CPT_strobe = false end
  if CPT_parm[12] == "true" then CPT_taxi = true else CPT_taxi = false end
	CPT_flap_d1  = tonumber(CPT_parm[13])
	CPT_flap_d2  = tonumber(CPT_parm[14])
	CPT_flap_u1  = tonumber(CPT_parm[15])
 	CPT_flap_time = tonumber(CPT_parm[16])
 if CPT_parm[17] == "true" then CPT_QNH_inhg = true else CPT_QNH_inhg = false end
	CPT_QNH_trans  = CPT_parm[18]
  
	RESUME_MOUSE_CLICK = true
end

CPT_load_settings()


-- ---------------------------------------------------------------------------------------------------------------- Find axis for Gear and Flaps
function CPT_get_axis()
  local axis_function_type_is = 0
  local i
  
  for i = 0, 99 do
    axis_function_type_is = get("sim/joystick/joystick_axis_assignments", i)
    if axis_function_type_is == 11 then ------------------------------------------------------------ FLAPS --
      CPT_axis_flap = i
    end
    if axis_function_type_is == 36 then ------------------------------------------------------------ GEAR --
      CPT_axis_gear = i
    end
  end
end

function CPT_flap_deakt()
  set_axis_assignment(CPT_axis_flap, "none", "normal")
end

function CPT_gear_deakt()
  set_axis_assignment(CPT_axis_gear, "none", "normal")
end

function CPT_flap_akt()
  set_axis_assignment(CPT_axis_flap, "flaps", "normal")
end

function CPT_gear_akt()
  set_axis_assignment(CPT_axis_gear, "landing gear", "normal")
end

CPT_get_axis()

if CPT_flap == true then 
  CPT_flap_deakt() 
else
  CPT_flap_akt() 
end

if CPT_gear == true then 
  CPT_gear_deakt() 
else
  CPT_gear_akt() 
end


-------------------------------------------------------------------------------------------------------------------

function CPT_show_tab() ------------------------------------------------------------------------------------------- Show CPT-Tab -----------
  if CPT_show == false then
    return
  end
    XPLMSetGraphicsState(0,0,0,1,1,0,0)
    graphics.set_color(0.0, 0.0, 0.8, 0.5)
    graphics.draw_rectangle(SCREEN_WIDTH-40, 0, SCREEN_WIDTH, 40)
    graphics.set_color(1, 1, 1, 1.0)
    draw_string_Helvetica_18(SCREEN_WIDTH-38, 15, "CPT")
    graphics.draw_line(SCREEN_WIDTH-40, 0, SCREEN_WIDTH, 0)  -- unten
    graphics.draw_line(SCREEN_WIDTH, 0, SCREEN_WIDTH, 40) -- rechts
    graphics.draw_line(SCREEN_WIDTH, 40, SCREEN_WIDTH-40, 40) -- oben
    graphics.draw_line(SCREEN_WIDTH-40, 40, SCREEN_WIDTH-40, 0) -- links
  
end
-------------------------------------------------------------------------------------

function CPT_show_functions() ------------------------------------------------------------------------------------- Show functions ----------
  if CPT_func==true and CPT_show == true then
  
  CPT_check_ATC()
  XPLMSetGraphicsState(0,0,0,1,1,0,0)
	
  graphics.set_color(0, 0, 0, 0.5)
  graphics.draw_rectangle(SCREEN_WIDTH-120, 0, SCREEN_WIDTH, 200)    -- Hhe anpassen !!!!!!
	
  if CPT_on == true then   -----------------------------------------------------show ON/OFF
    graphics.set_color(0.0, 0.8, 0.0, 0.5)
  else
    graphics.set_color(0.8, 0.0, 0.0, 0.5)
  end
  
  graphics.draw_rectangle(SCREEN_WIDTH-80, 0, SCREEN_WIDTH-40, 40)
  if CPT_on == true then 
    graphics.set_color(1.0, 1.0, 1.0, 1.0)
    draw_string_Helvetica_18(SCREEN_WIDTH-75, 15, "ON ")
  else
    graphics.set_color(1.0, 1.0, 1.0, 1.0)
    draw_string_Helvetica_18(SCREEN_WIDTH-78, 15, "OFF")
  end
  ------------------------------------------------------------------------------
  
  if CPT_voice == true then   ----------------------------------------------------show VOICE
    graphics.set_color(0.0, 0.8, 0.0, 0.5)
  else
    graphics.set_color(0.8, 0.0, 0.0, 0.5)
  end
  
  graphics.draw_rectangle(SCREEN_WIDTH-120, 0, SCREEN_WIDTH-80, 40)
  graphics.set_color(1.0, 1.0, 1.0, 1.0)
  draw_string_Helvetica_12(SCREEN_WIDTH-118, 15, "Voice")
  ----------------------------------------------------------------------------------
  
  
  if CPT_gear == true then   -----------------------------------------------------show GEAR
    if CPT_on == true then
      graphics.set_color(0.0, 0.8, 0.0, 0.5)
    else
      graphics.set_color(0.8, 0.0, 0.0, 0.5)
    end
  else
    graphics.set_color(0.8, 0.0, 0.0, 0.5)
  end
  
  graphics.draw_rectangle(SCREEN_WIDTH-40, 60, SCREEN_WIDTH, 80)
  graphics.set_color(1.0, 1.0, 1.0, 1.0)
  draw_string_Helvetica_12(SCREEN_WIDTH-34, 65, "Gear")
  
  for i = 0, 5 do
    if gear_deployment[i] == 1 then glColor4f(0,1,0,0.8)
    elseif gear_deployment[i] == 0 then glColor4f(0,0,0,0.8)
    else glColor4f(1,1,0,0.8) 
    end
    
    if gear_leglen[i] > 0 then
      graphics.draw_filled_circle(SCREEN_WIDTH-34+i*6, 50, 2)
    end
  end
  
  
  ------------------------------------------------------------------------------------
  
  
  if CPT_ATC == true then   ----------------------------------------------------------show ATC
    if CPT_on == true then
      graphics.set_color(0.0, 0.8, 0.0, 0.5)
    else
      graphics.set_color(0.8, 0.0, 0.0, 0.5)
    end
  else
    graphics.set_color(0.8, 0.0, 0.0, 0.5)
  end
  
  graphics.draw_rectangle(SCREEN_WIDTH-80, 60, SCREEN_WIDTH-40, 80)
  graphics.set_color(1.0, 1.0, 1.0, 1.0)
  draw_string_Helvetica_12(SCREEN_WIDTH-75, 65, " ATC ")
  
  if TRANSPONDER_MODE == 0 then
     graphics.set_color(0.0, 0.0, 0.0, 0.4)
  elseif TRANSPONDER_MODE == 1 then
    graphics.set_color(0.8, 0.0, 0.0, 0.4)
  elseif TRANSPONDER_MODE == 2 then
    graphics.set_color(0.0, 0.8, 0.0, 0.4)
  end
  graphics.draw_rectangle(SCREEN_WIDTH-80, 40, SCREEN_WIDTH-40, 59)
  graphics.set_color(1.0, 1.0, 1.0, 1.0)
  draw_string_Helvetica_12(SCREEN_WIDTH-74, 45, string.format("%04s", SQUAWK))
  
  -----------------------------------------------------------------------------------
  
  
  if CPT_QNH == true then   -----------------------------------------------------------show QNH
    if CPT_on == true then
      graphics.set_color(0.0, 0.8, 0.0, 0.5)
    else
      graphics.set_color(0.8, 0.0, 0.0, 0.5)
    end
  else
    graphics.set_color(0.8, 0.0, 0.0, 0.5)
  end
  
  graphics.draw_rectangle(SCREEN_WIDTH-120, 60, SCREEN_WIDTH-80, 80)
  graphics.set_color(1.0, 1.0, 1.0, 1.0)
  draw_string_Helvetica_12(SCREEN_WIDTH-118, 65, " QNH ")
  if CPT_set_trans == 1 then 
    draw_string_Helvetica_12(SCREEN_WIDTH-117, 45, string.format("%05.0f", CPT_QNH_trans))
  elseif CPT_set_trans == 2 then 
    if CPT_QNH_inhg == true then 
      draw_string_Helvetica_12(SCREEN_WIDTH-117, 45, " inHg ")
    else
      draw_string_Helvetica_12(SCREEN_WIDTH-117, 45, "  mB  ")
    end
  else
    if math.abs(CPT_xp_QNH_pilot - 29.92) < 0.009 then
      draw_string_Helvetica_12(SCREEN_WIDTH-112, 45, string.format("STD"))
    else
      if CPT_QNH_inhg == true then
        draw_string_Helvetica_12(SCREEN_WIDTH-115, 45, string.format("%.2f", CPT_xp_QNH_pilot))
      else
         draw_string_Helvetica_12(SCREEN_WIDTH-117, 45, string.format("%4.0f", CPT_xp_QNH_pilot * 33.8637526))
      end
    end
  end
  ------------------------------------------------------------
  
  if CPT_flap == true then   ----------------------------------------------------------show Flap
    if CPT_on == true then
      graphics.set_color(0.0, 0.8, 0.0, 0.5)
    else
      graphics.set_color(0.8, 0.0, 0.0, 0.5)
    end
  else
    graphics.set_color(0.8, 0.0, 0.0, 0.5)
  end
  graphics.draw_rectangle(SCREEN_WIDTH-40, 100, SCREEN_WIDTH, 120)
  graphics.set_color(1.0, 1.0, 1.0, 1.0)
  draw_string_Helvetica_12(SCREEN_WIDTH-35, 105, "Flaps")
  if CPT_dips_stat_flap == 0 then
    graphics.set_color(1.0, 1.0, 0.0, 0.8)
    graphics.draw_rectangle(SCREEN_WIDTH-40, 80, SCREEN_WIDTH-((1-CPT_xp_flap_pos) * 40), 100)
    graphics.set_color(0.0, 0.0, 0.0, 0.8)
    graphics.draw_rectangle(SCREEN_WIDTH-((1-CPT_xp_flap_pos) * 40), 80, SCREEN_WIDTH, 100)
  elseif CPT_dips_stat_flap == 1 then
    draw_string_Helvetica_12(SCREEN_WIDTH-39, 84, "d1 ")
    draw_string_Helvetica_12(SCREEN_WIDTH-24, 84, string.format("%1.1f", CPT_flap_d1))
  elseif CPT_dips_stat_flap == 2 then
    draw_string_Helvetica_12(SCREEN_WIDTH-39, 84, "d2 ")
    draw_string_Helvetica_12(SCREEN_WIDTH-24, 84, string.format("%1.1f", CPT_flap_d2))
  elseif CPT_dips_stat_flap == 3 then
    draw_string_Helvetica_12(SCREEN_WIDTH-39, 84, "u  ")
    draw_string_Helvetica_12(SCREEN_WIDTH-24, 84, string.format("%1.1f", CPT_flap_u1))
  elseif CPT_dips_stat_flap == 4 then
    draw_string_Helvetica_12(SCREEN_WIDTH-39, 84, "t  ")
    draw_string_Helvetica_12(SCREEN_WIDTH-24, 84, string.format("%2.0f", CPT_flap_time))
  end
  
  -- CPT_flap_time
  
  -----------------------------------------------------------------------------------
  
  if CPT_beacon == true then   ----------------------------------------------------------show Beacon
    if CPT_on == true then
      graphics.set_color(0.0, 0.8, 0.0, 0.5)
    else
      graphics.set_color(0.8, 0.0, 0.0, 0.5)
    end
  else
    graphics.set_color(0.8, 0.0, 0.0, 0.5)
  end
  graphics.draw_rectangle(SCREEN_WIDTH-80, 100, SCREEN_WIDTH-40, 120)
  graphics.set_color(1.0, 1.0, 1.0, 1.0)
  draw_string_Helvetica_12(SCREEN_WIDTH-75, 105, " Bcn ")
  if CPT_xp_beacon == 1 then
    graphics.set_color(1.0, 1.0, 0.0, 0.8)
  else
     graphics.set_color(0.0, 0.0, 0.0, 0.8)
  end
  graphics.draw_filled_circle(SCREEN_WIDTH-60, 90, 8)
  -----------------------------------------------------------------------------------
  
  if CPT_navl == true then   ----------------------------------------------------------show NavLights
    if CPT_on == true then
      graphics.set_color(0.0, 0.8, 0.0, 0.5)
    else
      graphics.set_color(0.8, 0.0, 0.0, 0.5)
    end
  else
    graphics.set_color(0.8, 0.0, 0.0, 0.5)
  end
  graphics.draw_rectangle(SCREEN_WIDTH-120, 100, SCREEN_WIDTH-80, 120)
  graphics.set_color(1.0, 1.0, 1.0, 1.0)
  draw_string_Helvetica_12(SCREEN_WIDTH-115, 105, "NavL.")
  
  if CPT_xp_navlight == 1 then
    graphics.set_color(1.0, 1.0, 0.0, 0.8)
  else
     graphics.set_color(0.0, 0.0, 0.0, 0.8)
  end
  graphics.draw_filled_circle(SCREEN_WIDTH-100, 90, 8)
  -----------------------------------------------------------------------------------
  
  if CPT_LL == true then   ----------------------------------------------------------show Landing Lights
    if CPT_on == true then
      graphics.set_color(0.0, 0.8, 0.0, 0.5)
    else
      graphics.set_color(0.8, 0.0, 0.0, 0.5)
    end
  else
    graphics.set_color(0.8, 0.0, 0.0, 0.5)
  end
  graphics.draw_rectangle(SCREEN_WIDTH-40, 140, SCREEN_WIDTH-0, 160)
  graphics.set_color(1.0, 1.0, 1.0, 1.0)
  draw_string_Helvetica_12(SCREEN_WIDTH-37, 145, "Land.L")
  
  if CPT_xp_landlight == 1 then
    graphics.set_color(1.0, 1.0, 0.0, 0.8)
  else
     graphics.set_color(0.0, 0.0, 0.0, 0.8)
 end
  graphics.draw_filled_circle(SCREEN_WIDTH-20, 130, 8)
  -----------------------------------------------------------------------------------
  
  if CPT_strobe == true then   ----------------------------------------------------------show Strobe Lights
    if CPT_on == true then
      graphics.set_color(0.0, 0.8, 0.0, 0.5)
    else
      graphics.set_color(0.8, 0.0, 0.0, 0.5)
    end
  else
    graphics.set_color(0.8, 0.0, 0.0, 0.5)
  end
  graphics.draw_rectangle(SCREEN_WIDTH-80, 140, SCREEN_WIDTH-40, 160)
  graphics.set_color(1.0, 1.0, 1.0, 1.0)
  draw_string_Helvetica_12(SCREEN_WIDTH-78, 145, "Strobe")
  
  if CPT_xp_strobelight == 1 then
    graphics.set_color(1.0, 1.0, 0.0, 0.8)
  else
     graphics.set_color(0.0, 0.0, 0.0, 0.8)
  end
  graphics.draw_filled_circle(SCREEN_WIDTH-60, 130, 8)
  -----------------------------------------------------------------------------------
  
  if CPT_taxi == true then   ----------------------------------------------------------show Taxi Lights
    if CPT_on == true then
      graphics.set_color(0.0, 0.8, 0.0, 0.5)
    else
      graphics.set_color(0.8, 0.0, 0.0, 0.5)
    end
  else
    graphics.set_color(0.8, 0.0, 0.0, 0.5)
  end
  graphics.draw_rectangle(SCREEN_WIDTH-120, 140, SCREEN_WIDTH-80, 160)
  graphics.set_color(1.0, 1.0, 1.0, 1.0)
  draw_string_Helvetica_12(SCREEN_WIDTH-118, 145, "Taxi L")
  
  if CPT_xp_taxilight == 1 then
    graphics.set_color(1.0, 1.0, 0.0, 0.8)
  else
     graphics.set_color(0.0, 0.0, 0.0, 0.8)
  end
  graphics.draw_filled_circle(SCREEN_WIDTH-100, 130, 8)
  -----------------------------------------------------------------------------------
  
  ------------ draw lines around the hole block graphics.draw_line( x1, y1, x2, y2 )
  graphics.set_color(1, 1, 1, 1)
  graphics.set_width(2)
  graphics.draw_line(SCREEN_WIDTH-120, 0, SCREEN_WIDTH, 0)        -- horiz. "0"
  graphics.draw_line(SCREEN_WIDTH-120, 40, SCREEN_WIDTH, 40)     -- horiz. "1"
  graphics.draw_line(SCREEN_WIDTH-120, 80, SCREEN_WIDTH, 80)     -- horiz. "2"
  graphics.draw_line(SCREEN_WIDTH-120, 120, SCREEN_WIDTH, 120)     -- horiz. "3"
  graphics.draw_line(SCREEN_WIDTH-120, 160, SCREEN_WIDTH, 160)     -- horiz. "4"
  graphics.draw_line(SCREEN_WIDTH-120, 180, SCREEN_WIDTH, 180)     -- horiz. "5"
  
  graphics.draw_line(SCREEN_WIDTH-120, 0, SCREEN_WIDTH-120, 180)   -- vert. "3"
  graphics.draw_line(SCREEN_WIDTH-80, 0, SCREEN_WIDTH-80, 160)   -- vert. "2"
  graphics.draw_line(SCREEN_WIDTH-40, 0, SCREEN_WIDTH-40, 160)     -- vert. "1"
  graphics.draw_line(SCREEN_WIDTH-0, 0, SCREEN_WIDTH-0, 180)       -- vert. "0"
  
  graphics.set_width(1)
  graphics.draw_line(SCREEN_WIDTH-80, 160, SCREEN_WIDTH-80, 180)   -- vert. "2" SMALL
  graphics.draw_line(SCREEN_WIDTH-40, 160, SCREEN_WIDTH-40, 180)   -- vert. "3" SMALL
  
  draw_string_Helvetica_12(SCREEN_WIDTH-115, 165, "Save")
  draw_string_Helvetica_12(SCREEN_WIDTH-75, 165, "STD")
  draw_string_Helvetica_12(SCREEN_WIDTH-35, 165, "ACF")
  
  if CPT_debug == true then
    if CPT_flap == true then draw_string_Helvetica_12(SCREEN_WIDTH-125, 225, "true") else draw_string_Helvetica_12(SCREEN_WIDTH-125, 225,  "false") end
    draw_string_Helvetica_12(SCREEN_WIDTH-125, 205, string.format("%.1f", CPT_xp_AoA))
    draw_string_Helvetica_12(SCREEN_WIDTH-95, 205, string.format("%.1f", CPT_flap_d1))
    draw_string_Helvetica_12(SCREEN_WIDTH-65, 225, string.format("%.1f", os.clock()))
    draw_string_Helvetica_12(SCREEN_WIDTH-35, 205, string.format("%.1f", CPT_flap_last))
  end
  CPT_show_tab()
  
  end 
  
  if string.len(CPT_message) > 0 then
    if CPT_voice == true and CPT_sound_played == false then
      play_sound(sound_warning)            -- <---------------------
      CPT_sound_played = true
    end
    graphics.set_color(1, 0, 0, 0.8)
    graphics.draw_rectangle(SCREEN_WIDTH-120, 180, SCREEN_WIDTH, 200)
    graphics.set_color(1, 1, 1, 1)
    draw_string_Helvetica_12(SCREEN_WIDTH-118, 187, CPT_message)
    if os.clock() > CPT_message_end then CPT_message = "" end
  else
    if CPT_func==true and CPT_show == true then
      draw_string_Helvetica_12(SCREEN_WIDTH-118, 187, "Copilot V1.0 oe3gsu")
    end 
    CPT_message_end = os.clock() + CPT_message_time
    CPT_sound_played = false
  end
  
end
do_every_draw("CPT_show_tab()")
------------------------------------------------------------------------------------

function CPT_mouse_click_events() --------------------------------------------------------------------------------- Mouse Click -----------
  if MOUSE_STATUS ~= "down" or CPT_show == false then
    return
  end
  
  ------------------------------------------------------------------------------------------------------------ TAB
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-40 and MOUSE_X < SCREEN_WIDTH and MOUSE_Y < 40 and MOUSE_Y > 0 then
    if CPT_func == false then
      CPT_func = true
      if CPT_voice == true then play_sound(sound_welcome) end
    else 
      CPT_func = false
    end
    if CPT_func == true then
      do_every_draw("CPT_show_functions()")
    end
    RESUME_MOUSE_CLICK = true
  end
  ---------------------------------------------------------------------------------------------------------------
  
  ------------------------------------------------------------------------------------------------------------- ON/OFF
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-80 and MOUSE_X < SCREEN_WIDTH-40 and MOUSE_Y < 40 and MOUSE_Y > 0 then
    if CPT_on == false then
      CPT_on = true
      if CPT_voice == true then play_sound(sound_command) end
    else 
      CPT_on = false
      if CPT_voice == true then play_sound(sound_coffee) end
    end
    RESUME_MOUSE_CLICK = true
  end
  --------------------------------------------------------------------------------------------------------------------
  
  ------------------------------------------------------------------------------------------------------------------- VOICE
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-120 and MOUSE_X < SCREEN_WIDTH-80 and MOUSE_Y < 40 and MOUSE_Y > 0 then
    CPT_voice = not CPT_voice
    RESUME_MOUSE_CLICK = true
  end
  ---------------------------------------------------------------------------------------------------------------------
  
  ------------------------------------------------------------------------------------------------------------------- GEAR
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-40 and MOUSE_X < SCREEN_WIDTH and MOUSE_Y < 80 and MOUSE_Y > 60 then
    if CPT_gear == false then
      CPT_gear = true
      CPT_gear_deakt()
    else 
      CPT_gear = false
      CPT_gear_akt()
   end
   RESUME_MOUSE_CLICK = true
  end
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-40 and MOUSE_X < SCREEN_WIDTH and MOUSE_Y < 60 and MOUSE_Y > 40 then
   CPT_gear = false
   CPT_gear_akt()
   if CPT_xp_gear_handle == 0 then CPT_xp_gear_handle = 1 else CPT_xp_gear_handle = 0 end
   RESUME_MOUSE_CLICK = true
  end
  --------------------------------------------------------------------------------------------------------------------
  
  ------------------------------------------------------------------------------------------------------------------ ATC
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-80 and MOUSE_X < SCREEN_WIDTH -40 and MOUSE_Y < 80 and MOUSE_Y > 60 then
    CPT_ATC = not CPT_ATC
    RESUME_MOUSE_CLICK = true
  end
  -------------------------------------------------------------------------------------------------------------------
  
  ------------------------------------------------------------------------------------------------------------------ QNH
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-120 and MOUSE_X < SCREEN_WIDTH -80 and MOUSE_Y < 80 and MOUSE_Y > 60 then
    CPT_QNH = not CPT_QNH
    RESUME_MOUSE_CLICK = true
  end
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-120 and MOUSE_X < SCREEN_WIDTH -80 and MOUSE_Y < 60 and MOUSE_Y > 40 then
    CPT_set_trans = CPT_set_trans + 1
    if CPT_set_trans > 2 then CPT_set_trans = 0 end
    RESUME_MOUSE_CLICK = true
  end
  --------------------------------------------------------------------------------------------------------------------
  
    ------------------------------------------------------------------------------------------------------------------ Flaps
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-40 and MOUSE_X < SCREEN_WIDTH - 0 and MOUSE_Y < 120 and MOUSE_Y > 100 then
    if CPT_flap == false then
      CPT_flap = true
    CPT_flap_deakt()
    else 
      CPT_flap = false
      CPT_flap_akt()
    end
    RESUME_MOUSE_CLICK = true
  end
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-40 and MOUSE_X < SCREEN_WIDTH - 0 and MOUSE_Y < 100 and MOUSE_Y > 80 then
    CPT_dips_stat_flap = CPT_dips_stat_flap +1
    if CPT_dips_stat_flap > 4 then CPT_dips_stat_flap = 0 end
  RESUME_MOUSE_CLICK = true
  end
  --------------------------------------------------------------------------------------------------------------------
  
    ------------------------------------------------------------------------------------------------------------------ Beacon
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-80 and MOUSE_X < SCREEN_WIDTH - 40 and MOUSE_Y < 120 and MOUSE_Y > 100 then
    CPT_beacon = not CPT_beacon
    RESUME_MOUSE_CLICK = true
  end
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-80 and MOUSE_X < SCREEN_WIDTH - 40 and MOUSE_Y < 100 and MOUSE_Y > 80 then
    if CPT_xp_beacon == 0 then CPT_xp_beacon = 1 else CPT_xp_beacon = 0 end
    CPT_beacon = false
    RESUME_MOUSE_CLICK = true
  end
  --------------------------------------------------------------------------------------------------------------------
  
    ------------------------------------------------------------------------------------------------------------------ Nav.Lights
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-120 and MOUSE_X < SCREEN_WIDTH - 80 and MOUSE_Y < 120 and MOUSE_Y > 100 then
    CPT_navl = not CPT_navl
    RESUME_MOUSE_CLICK = true
  end
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-120 and MOUSE_X < SCREEN_WIDTH - 80 and MOUSE_Y < 100 and MOUSE_Y > 80 then
    if CPT_xp_navlight == 0 then CPT_xp_navlight = 1 else CPT_xp_navlight = 0 end
    CPT_navl = false
    RESUME_MOUSE_CLICK = true
  end
  --------------------------------------------------------------------------------------------------------------------
  
  ---------------------------------------------------------------------------------------------------------------------- Landing Lights
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-40 and MOUSE_X < SCREEN_WIDTH - 0 and MOUSE_Y < 160 and MOUSE_Y > 140 then
    CPT_LL = not CPT_LL
    RESUME_MOUSE_CLICK = true
  end
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-40 and MOUSE_X < SCREEN_WIDTH - 0 and MOUSE_Y < 140 and MOUSE_Y > 120 then
    if CPT_xp_landlight == 0 then CPT_xp_landlight = 1 else CPT_xp_landlight = 0 end
    CPT_LL = false
    RESUME_MOUSE_CLICK = true
  end
  --------------------------------------------------------------------------------------------------------------------
  
  ---------------------------------------------------------------------------------------------------------------------- Strobe Lights
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-80 and MOUSE_X < SCREEN_WIDTH - 40 and MOUSE_Y < 160 and MOUSE_Y > 140 then
    CPT_strobe = not CPT_strobe
    RESUME_MOUSE_CLICK = true
  end
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-80 and MOUSE_X < SCREEN_WIDTH - 40 and MOUSE_Y < 140 and MOUSE_Y > 120 then
    if CPT_xp_strobelight == 0 then CPT_xp_strobelight = 1 else CPT_xp_strobelight = 0 end
    CPT_strobe = false
    RESUME_MOUSE_CLICK = true
  end
  --------------------------------------------------------------------------------------------------------------------
  
  ---------------------------------------------------------------------------------------------------------------------- Taxi Lights
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-120 and MOUSE_X < SCREEN_WIDTH - 80 and MOUSE_Y < 160 and MOUSE_Y > 140 then
    CPT_taxi = not CPT_taxi
    RESUME_MOUSE_CLICK = true
  end
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-120 and MOUSE_X < SCREEN_WIDTH - 80 and MOUSE_Y < 140 and MOUSE_Y > 120 then
    if CPT_xp_taxilight == 0 then CPT_xp_taxilight = 1 else CPT_xp_taxilight = 0 end
    CPT_taxi = false
    RESUME_MOUSE_CLICK = true
  end
  --------------------------------------------------------------------------------------------------------------------
  
  ----------------------------------------------------------------------------------------------------------------------- Save Standard Config
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-80 and MOUSE_X < SCREEN_WIDTH - 40 and MOUSE_Y < 180 and MOUSE_Y > 160 then
    CPT_message = "      File saved"
    CPT_save_std_config()
    RESUME_MOUSE_CLICK = true
  end 
  ----------------------------------------------------------------------------------------------------------------------- Save Aircraft Config
  if CPT_show == true and MOUSE_X > SCREEN_WIDTH-40 and MOUSE_X < SCREEN_WIDTH - 0 and MOUSE_Y < 180 and MOUSE_Y > 160 then
    CPT_message = "      File saved"
    CPT_save_acf_config()
    RESUME_MOUSE_CLICK = true
  end 

end

do_on_mouse_click("CPT_mouse_click_events()")
-----------------------------------------------------------------------------------

function CPT_mouse_wheel_events() --------------------------------------------------------------------------------- Mouse Wheel -----------
  if CPT_show == false or CPT_on == false    then --- are we visible and active?
    return
  end
  if MOUSE_X > SCREEN_WIDTH-40 and MOUSE_X < SCREEN_WIDTH -0 and MOUSE_Y < 100 and MOUSE_Y > 80  and CPT_dips_stat_flap == 0 then -- FLAPS manually
    CPT_flap = false
    if MOUSE_WHEEL_CLICKS > 0 then
      CPT_xp_flap_handle = CPT_xp_flap_handle + CPT_flap_step
      if CPT_xp_flap_handle > 1 then CPT_xp_flap_handle = 1 end
    elseif MOUSE_WHEEL_CLICKS < 0 then
      CPT_xp_flap_handle = CPT_xp_flap_handle - CPT_flap_step
      if CPT_xp_flap_handle < 0 then CPT_xp_flap_handle = 0 end
    end
  end
  
  
  
  
  if CPT_set_trans == 0 then ------------------------------------------------------------------------------ set QNH manually
    if MOUSE_X > SCREEN_WIDTH-120 and MOUSE_X < SCREEN_WIDTH -80 and MOUSE_Y < 60 and MOUSE_Y > 40  then -- QNH
    if CPT_QNH == false then
      CPT_xp_QNH_pilot = CPT_xp_QNH_pilot + (MOUSE_WHEEL_CLICKS/100)
    end
    RESUME_MOUSE_WHEEL = true
    end 
  elseif CPT_set_trans == 1 then -- set Transition manually-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
    if MOUSE_X > SCREEN_WIDTH-120 and MOUSE_X < SCREEN_WIDTH -80 and MOUSE_Y < 60 and MOUSE_Y > 40  then -- QNH
      CPT_QNH_trans = CPT_QNH_trans + (MOUSE_WHEEL_CLICKS*1000)
      if CPT_QNH_trans < 1000 then CPT_QNH_trans = 1000 end
      if CPT_QNH_trans >= 99000 then CPT_QNH_trans = 99000 end
      RESUME_MOUSE_WHEEL = true
    end 
  elseif CPT_set_trans == 2 then -- set inHG manually
    if MOUSE_X > SCREEN_WIDTH-120 and MOUSE_X < SCREEN_WIDTH -80 and MOUSE_Y < 60 and MOUSE_Y > 40  then -- QNH
      if MOUSE_WHEEL_CLICKS > 0 then
        CPT_QNH_inhg = true
      else
        CPT_QNH_inhg = false
      end
    end
    RESUME_MOUSE_WHEEL = true
  end-------------------------------------------------------------------
  
  if MOUSE_X > SCREEN_WIDTH-80 and MOUSE_X < SCREEN_WIDTH -70 and MOUSE_Y < 60 and MOUSE_Y > 40  then -- ATC T
      SQUAWK = SQUAWK + (MOUSE_WHEEL_CLICKS*1000)
      CPT_check_ATC()
    RESUME_MOUSE_WHEEL = true
  end -------------------------------------------------------------------
  if MOUSE_X > SCREEN_WIDTH-70 and MOUSE_X < SCREEN_WIDTH -60 and MOUSE_Y < 60 and MOUSE_Y > 40  then -- ATC H
      SQUAWK = SQUAWK + (MOUSE_WHEEL_CLICKS*100)
      CPT_check_ATC()
    RESUME_MOUSE_WHEEL = true
  end -------------------------------------------------------------------
  if MOUSE_X > SCREEN_WIDTH-60 and MOUSE_X < SCREEN_WIDTH -50 and MOUSE_Y < 60 and MOUSE_Y > 40  then -- ATC Z
    CPT_check_ATC()
    SQUAWK = SQUAWK + (MOUSE_WHEEL_CLICKS*10)
    RESUME_MOUSE_WHEEL = true
  end -------------------------------------------------------------------
  if MOUSE_X > SCREEN_WIDTH-50 and MOUSE_X < SCREEN_WIDTH -40 and MOUSE_Y < 60 and MOUSE_Y > 40  then -- ATC E
    CPT_check_ATC()
    SQUAWK = SQUAWK + (MOUSE_WHEEL_CLICKS*1)
    RESUME_MOUSE_WHEEL = true
  end -------------------------------------------------------------------
  if MOUSE_X > SCREEN_WIDTH-40 and MOUSE_X < SCREEN_WIDTH - 0 and MOUSE_Y < 100 and MOUSE_Y > 80 then
    if CPT_dips_stat_flap == 1 then 
      CPT_flap_d1 = CPT_flap_d1 + (MOUSE_WHEEL_CLICKS*0.1) -- 5
      if CPT_flap_d1 > CPT_flap_d2 then CPT_flap_d1 = CPT_flap_d2 end
      if CPT_flap_d1 < CPT_flap_u1 then CPT_flap_d1 = CPT_flap_u1 end
    elseif CPT_dips_stat_flap == 2 then 
      CPT_flap_d2 = CPT_flap_d2 + (MOUSE_WHEEL_CLICKS*0.1) -- 10
      if CPT_flap_d2 > 19.9 then CPT_flap_d2 = 19.9 end
      if CPT_flap_d2 < CPT_flap_d1 then CPT_flap_d2 = CPT_flap_d1 end
    elseif CPT_dips_stat_flap == 3 then 
      CPT_flap_u1 = CPT_flap_u1 + (MOUSE_WHEEL_CLICKS*0.1) -- -0.5
      if CPT_flap_u1 < -2.0 then CPT_flap_u1 = -2.0 end 
      if CPT_flap_u1 > CPT_flap_d1 then CPT_flap_u1 = CPT_flap_d1 end
     elseif CPT_dips_stat_flap == 4 then 
      CPT_flap_time = CPT_flap_time + (MOUSE_WHEEL_CLICKS*1) -- -0.5
      if CPT_flap_time < 1.0 then CPT_flap_time = 1.0 end 
      if CPT_flap_time > 20.0 then CPT_flap_time = 20.0 end
   end
    RESUME_MOUSE_WHEEL = true
	end
end -------------------------------------------------------------------------------------------------------------------------------------

do_on_mouse_wheel("CPT_mouse_wheel_events()")

function CPT_save_std_config() ------------------------------------------------------------------------------------- Save standard config
  file = io.open(SCRIPT_DIRECTORY .. "CPT_std.cpt", "w")
  file:write (tostring(CPT_func), "\n", tostring(CPT_on), "\n", tostring(CPT_voice), "\n", tostring(CPT_gear), "\n", tostring(CPT_ATC), "\n", tostring(CPT_QNH), "\n", 
  tostring(CPT_flap), "\n", tostring(CPT_beacon), "\n", tostring(CPT_navl), "\n", tostring(CPT_LL), "\n", tostring(CPT_strobe), "\n", tostring(CPT_taxi), "\n", CPT_flap_d1, "\n", 
  CPT_flap_d2, "\n", CPT_flap_u1, "\n", CPT_flap_time, "\n", tostring(CPT_QNH_inhg), "\n", CPT_QNH_trans)
  file:close()
end

function CPT_save_acf_config()  ------------------------------------------------------------------------------------- Save aircraft config
  file = io.open(AIRCRAFT_PATH .. string.sub(AIRCRAFT_FILENAME, 1, string.len(AIRCRAFT_FILENAME)-4 ) .. ".cpt", "w")
  file:write (tostring(CPT_func), "\n", tostring(CPT_on), "\n", tostring(CPT_voice), "\n", tostring(CPT_gear), "\n", tostring(CPT_ATC), "\n", tostring(CPT_QNH), "\n", 
  tostring(CPT_flap), "\n", tostring(CPT_beacon), "\n", tostring(CPT_navl), "\n", tostring(CPT_LL), "\n", tostring(CPT_strobe), "\n", tostring(CPT_taxi), "\n", CPT_flap_d1, "\n", 
  CPT_flap_d2, "\n", CPT_flap_u1, "\n", CPT_flap_time, "\n", tostring(CPT_QNH_inhg), "\n", CPT_QNH_trans)
  file:close()
end

function CPT_check_ATC() ------------------------------------------------------------------------------------------ Check ATC -----------
  CPT_ATC_t = math.floor(SQUAWK/1000)
  CPT_ATC_h = math.floor((SQUAWK-(CPT_ATC_t * 1000)) / 100)
  CPT_ATC_z = math.floor((SQUAWK-(CPT_ATC_t * 1000) - (CPT_ATC_h * 100)) / 10)
  CPT_ATC_e = math.floor((SQUAWK-(CPT_ATC_t * 1000) - (CPT_ATC_h * 100) - (CPT_ATC_z * 10)))
  
  if CPT_ATC_t >= 8 then 
    CPT_ATC_t = 7 
  end
  if CPT_ATC_h >= 8 then 
    CPT_ATC_h = 7 
  end
  if CPT_ATC_z >= 8 then 
    CPT_ATC_z = 7 
  end
  if CPT_ATC_e >= 8 then 
    CPT_ATC_e = 7 
  end
  if CPT_ATC_t < 0 then 
    CPT_ATC_t = 0 end
  if CPT_ATC_h < 0 then 
    CPT_ATC_h = 0 
  end
  if CPT_ATC_z < 0 then 
    CPT_ATC_z = 0 
  end
  if CPT_ATC_e < 0 then 
    CPT_ATC_e = 0 
  end
  SQUAWK = (CPT_ATC_t * 1000) + (CPT_ATC_h * 100) + (CPT_ATC_z * 10) + CPT_ATC_e
end

----------------------------------------------------------------------------------

function CPT_main() ----------------------------------------------------------------------------------------------- MAIN -----------
  
  ----------------------------------------------------------------------------------------------------------------- Set STATUS 
  CPT_y_agl_ft = CPT_xp_y_agl -- / 0.32808399
  
  if CPT_xp_gs_act < 1                         and CPT_y_agl_ft < 10                                 and CPT_xp_fnrml_gear > 100                                                      then CPT_status = 0 end --On Blocks
  if CPT_xp_gs_act > 1  and CPT_xp_gs_act < 15 and CPT_y_agl_ft < 10                                 and CPT_xp_fnrml_gear > 100                                                      then CPT_status = 1 end --Taxi
  if CPT_xp_gs_act > 15 and CPT_xp_gs_act < 40 and CPT_y_agl_ft < 50                                 and CPT_xp_fnrml_gear < 100                                                      then CPT_status = 2 end --Takoff
  if CPT_xp_gs_act > 40                        and CPT_xp_cur_alt > 80   and CPT_xp_cur_alt < 100000 and CPT_xp_fnrml_gear < 100 and CPT_xp_cur_alt > (CPT_last_heigt + 20)           then CPT_status = 3 end --Climb
  if CPT_xp_gs_act > 40                        and CPT_xp_cur_alt > 4000 and CPT_xp_cur_alt < 100000 and CPT_xp_fnrml_gear < 100 and math.abs (CPT_xp_cur_alt - CPT_last_heigt) < 50  then CPT_status = 4 end --Cruise
  if CPT_xp_gs_act > 40                        and CPT_xp_cur_alt > 10000                            and CPT_xp_fnrml_gear < 100 and math.abs (CPT_xp_cur_alt - CPT_last_heigt) < 50  then CPT_status = 5 end --Above FL100
  if CPT_xp_gs_act > 40                        and CPT_xp_cur_alt > 4000 and CPT_xp_cur_alt < 100000 and CPT_xp_fnrml_gear < 100 and CPT_xp_cur_alt < CPT_last_heigt -20             then CPT_status = 6 end --Descent
  if CPT_xp_gs_act > 40                        and CPT_xp_cur_alt > 1000 and CPT_xp_cur_alt < 4000   and CPT_xp_fnrml_gear < 100 and CPT_xp_cur_alt < CPT_last_heigt -20             then CPT_status = 7 end --Approach
  if CPT_xp_gs_act > 40                        and CPT_y_agl_ft > 10     and CPT_y_agl_ft < 1000     and CPT_xp_fnrml_gear < 100 and CPT_xp_cur_alt < CPT_last_heigt -20              then CPT_status = 8 end --Final
  --if CPT_xp_gs_act > 15 and CPT_xp_gs_act < 40 and CPT_y_agl_ft < 10                                 and CPT_xp_fnrml_gear > 100                                                      then CPT_status = 9 end --Touchdown
  
  if CPT_xp_y_agl > 1000 then
    if CPT_xp_Vno < 10 then CPT_xp_Vno = CPT_xp_Vne * 0.9 end
    if CPT_xp_IAS > CPT_xp_Vno and CPT_xp_Vno > 10 then CPT_message = " Speed over Vno" end
    if CPT_xp_IAS > CPT_xp_Vne then CPT_message = " Speed over Vne" end
    if CPT_xp_IAS < CPT_xp_Vs then CPT_message = " Speed below Vs" end
    if CPT_xp_IAS < CPT_xp_Vso and CPT_status < 7 then CPT_message = " Speed below Vso" end
  end
  
  if CPT_gear == true and CPT_on == true then --------------------------------------------------------------------- Switch GEAR 
    if CPT_xp_gs_act > 40 and CPT_agl_old < CPT_xp_y_agl and CPT_y_agl_ft > 200 and CPT_xp_gear_handle > 0 then -- GearUP 
      CPT_xp_gear_handle = 0
      if CPT_voice == true then play_sound(sound_gearup) end
    end
    if (CPT_y_agl_ft < 1000 or CPT_xp_OM_lit > 0) and CPT_agl_old > CPT_xp_y_agl and CPT_xp_gear_handle < 1 then -- GearDOWN 
      CPT_xp_gear_handle = 1
      if CPT_voice == true then play_sound(sound_geardown) end
    end
    if CPT_xp_gear_unsafe == 0 and CPT_gear_old == 1 then
      if CPT_voice == true then
        if CPT_xp_gear_handle == 0 then
          play_sound(sound_gearisup) 
        else
          play_sound(sound_gearisdown)
        end
      end
    end
    CPT_gear_old = CPT_xp_gear_unsafe 
  end ------------------------------------------------------------------------------------------------------------- GEAR END
  
  if CPT_ATC == true and CPT_on == true then----------------------------------------------------------------------- Switch Squawk and Landing Light
    if CPT_status > 1 and TRANSPONDER_MODE ~= 2 then 
      TRANSPONDER_MODE = 2
      CPT_xp_strobelight = 1
      CPT_xp_landlight = 1
      if CPT_voice == true then play_sound(sound_squawk_on) end
    end
    if CPT_status == 1 and TRANSPONDER_MODE ~= 1 then 
      TRANSPONDER_MODE = 1
      CPT_xp_strobelight = 0
      CPT_xp_landlight = 0
      if CPT_voice == true then play_sound(sound_squawk_stby) end
    end
  end ------------------------------------------------------------------------------------------------------------- ATC END
  
  if CPT_QNH == true and CPT_on == true then ---------------------------------------------------------------------- Switch QNH 
    if CPT_xp_cur_alt > (CPT_QNH_trans + 200) and math.abs(CPT_xp_QNH_pilot - 29.92) > 0.01 then
      CPT_xp_QNH_pilot = 29.92
      if CPT_voice == true then play_sound(sound_qnhstd) end
    end
    if CPT_xp_cur_alt < (CPT_QNH_trans - 200) and math.abs(CPT_xp_QNH_pilot - CPT_xp_QNH_real) > 0.01 then
      CPT_xp_QNH_pilot = CPT_xp_QNH_real
      if CPT_voice == true then play_sound(sound_qnhloc) end
    end
  end-------------------------------------------------------------------------------------------------------------- QNH END
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  -- local CPT_flap_last = 0            -- Time flaps last movement
  -- local CPT_flap_time = 10           -- Time to wait before new flap movement


  if CPT_flap == true and CPT_on == true then --------------------------------------------------------------------- Switch Flaps
    
    if CPT_xp_gs_act > 40 then
      if CPT_y_agl_ft > 2000 and CPT_xp_AoA > CPT_flap_d1 and os.clock() > (CPT_flap_last + CPT_flap_time) then ------------------------------------------------------ Flaps Down D1
        if CPT_xp_flap_handle > 0.95 then 
          CPT_message = "Flaps are full down"
        else
          CPT_xp_flap_handle = CPT_xp_flap_handle + CPT_flap_step
          if CPT_voice == true then play_sound(sound_flaps_down) end -- 
        end
        CPT_flap_last = os.clock()
      end
      if CPT_y_agl_ft < 2000 and CPT_xp_AoA > CPT_flap_d2 and os.clock() > (CPT_flap_last + CPT_flap_time) then ------------------------------------------------------ Flaps Down D2
        if CPT_xp_flap_handle > 0.95 then 
          CPT_message = "Flaps are full down"
        else
          CPT_xp_flap_handle = CPT_xp_flap_handle + CPT_flap_step
          if CPT_voice == true then play_sound(sound_flaps_down) end -- 
        end
        CPT_flap_last = os.clock()
      end
    end
    if CPT_xp_gs_act > 40 and CPT_y_agl_ft > 20 and CPT_xp_AoA < CPT_flap_u1 and os.clock() > (CPT_flap_last + CPT_flap_time) then ----------------------------------- Flaps Up
      if CPT_xp_flap_handle < 0.05 then 
        CPT_message = "Flaps are full up"
      else
        CPT_xp_flap_handle = CPT_xp_flap_handle - CPT_flap_step
        if CPT_voice == true then play_sound(sound_flaps_up) end -- 
      end
      CPT_flap_last = os.clock()
    end
  end ------------------------------------------------------------------------------------------------------------- End Flaps
  
    if CPT_beacon == true and CPT_on == true then------------------------------------------------------------------ Switch Beacon Lights
    local i
    local CPT_any_eng_run = 0
    for i = 0, CPT_xp_eng_count do
      if get("sim/flightmodel/engine/ENGN_running", i) > 0 then
        CPT_any_eng_run = 1
      end
    end
    if CPT_any_eng_run > 0 then 
      CPT_xp_beacon = 1
    else
      CPT_xp_beacon = 0
    end
  end  ------------------------------------------------------------------------------------------------------------ END Beacon Lights
  
  if CPT_navl == true and CPT_on == true then---------------------------------------------------------------------- Switch Navigation Lights
    if CPT_xp_bat_on == 1 and CPT_xp_navlight < 1 then
      CPT_xp_navlight = 1
    end
    if CPT_xp_bat_on == 0 and CPT_xp_navlight > 0 then
      CPT_xp_navlight = 0
    end
  end ------------------------------------------------------------------------------------------------------------- END Navigation Lights
  
  if CPT_LL == true and CPT_on == true then ----------------------------------------------------------------------- Switch LL
    if CPT_xp_cur_alt > 10000 and CPT_last_heigt < 10000 --[[and CPT_xp_landlight == 1--]] then CPT_xp_landlight = 0 end
    if CPT_xp_cur_alt < 10000 and CPT_last_heigt > 10000 --[[and CPT_xp_landlight == 0--]] then CPT_xp_landlight = 1 end
  end-------------------------------------------------------------------------------------------------------------- LL END
  
  if CPT_taxi == true and CPT_on == true then---------------------------------------------------------------------- Switch Taxi Lights
    if CPT_status == 1 and CPT_xp_taxilight < 1 then
      CPT_xp_taxilight = 1
    end
    if CPT_status ~= 1 and CPT_xp_taxilight > 0 then
      CPT_xp_taxilight = 0
    end
  end ------------------------------------------------------------------------------------------------------------- END Navigation Lights
  
  CPT_old_status = CPT_status
  CPT_last_fnrml_gear = PT_xp_fnrml_gear
  CPT_count = CPT_count + 1
  if CPT_count > 1  then 
    CPT_count = 0
    CPT_last_heigt = CPT_xp_cur_alt
    CPT_agl_old = CPT_xp_y_agl
    CPT_last_y_agl = CPT_xp_y_agl
  end
end---------------------------------------------------------------------------------------------------------------- MAIN END
do_often("CPT_main()")
-----------------------------------------------------------------------------------